# coding: utf-8

"""
    Postmark API

    Postmark makes sending and receiving email incredibly easy. 

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class TemplateDetailResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, name=None, template_id=None, html_body=None, text_body=None, associated_server_id=None, subject=None, active=None):
        """
        TemplateDetailResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'template_id': 'int',
            'html_body': 'str',
            'text_body': 'str',
            'associated_server_id': 'int',
            'subject': 'str',
            'active': 'bool'
        }

        self.attribute_map = {
            'name': 'Name',
            'template_id': 'TemplateID',
            'html_body': 'HtmlBody',
            'text_body': 'TextBody',
            'associated_server_id': 'AssociatedServerId',
            'subject': 'Subject',
            'active': 'Active'
        }

        self._name = None
        self._template_id = None
        self._html_body = None
        self._text_body = None
        self._associated_server_id = None
        self._subject = None
        self._active = None

        # TODO: let required properties as mandatory parameter in the constructor.
        #       - to check if required property is not None (e.g. by calling setter)
        #       - ApiClient.__deserialize_model has to be adapted as well
        if name is not None:
          self.name = name
        if template_id is not None:
          self.template_id = template_id
        if html_body is not None:
          self.html_body = html_body
        if text_body is not None:
          self.text_body = text_body
        if associated_server_id is not None:
          self.associated_server_id = associated_server_id
        if subject is not None:
          self.subject = subject
        if active is not None:
          self.active = active

    @property
    def name(self):
        """
        Gets the name of this TemplateDetailResponse.
        The display name for the template.

        :return: The name of this TemplateDetailResponse.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this TemplateDetailResponse.
        The display name for the template.

        :param name: The name of this TemplateDetailResponse.
        :type: str
        """

        self._name = name

    @property
    def template_id(self):
        """
        Gets the template_id of this TemplateDetailResponse.
        The ID associated with the template.

        :return: The template_id of this TemplateDetailResponse.
        :rtype: int
        """
        return self._template_id

    @template_id.setter
    def template_id(self, template_id):
        """
        Sets the template_id of this TemplateDetailResponse.
        The ID associated with the template.

        :param template_id: The template_id of this TemplateDetailResponse.
        :type: int
        """

        self._template_id = template_id

    @property
    def html_body(self):
        """
        Gets the html_body of this TemplateDetailResponse.
        The content to use for the HtmlBody when this template is used to send email.

        :return: The html_body of this TemplateDetailResponse.
        :rtype: str
        """
        return self._html_body

    @html_body.setter
    def html_body(self, html_body):
        """
        Sets the html_body of this TemplateDetailResponse.
        The content to use for the HtmlBody when this template is used to send email.

        :param html_body: The html_body of this TemplateDetailResponse.
        :type: str
        """

        self._html_body = html_body

    @property
    def text_body(self):
        """
        Gets the text_body of this TemplateDetailResponse.
        The content to use for the TextBody when this template is used to send email.

        :return: The text_body of this TemplateDetailResponse.
        :rtype: str
        """
        return self._text_body

    @text_body.setter
    def text_body(self, text_body):
        """
        Sets the text_body of this TemplateDetailResponse.
        The content to use for the TextBody when this template is used to send email.

        :param text_body: The text_body of this TemplateDetailResponse.
        :type: str
        """

        self._text_body = text_body

    @property
    def associated_server_id(self):
        """
        Gets the associated_server_id of this TemplateDetailResponse.
        The ID of the Server with which this template is associated.

        :return: The associated_server_id of this TemplateDetailResponse.
        :rtype: int
        """
        return self._associated_server_id

    @associated_server_id.setter
    def associated_server_id(self, associated_server_id):
        """
        Sets the associated_server_id of this TemplateDetailResponse.
        The ID of the Server with which this template is associated.

        :param associated_server_id: The associated_server_id of this TemplateDetailResponse.
        :type: int
        """

        self._associated_server_id = associated_server_id

    @property
    def subject(self):
        """
        Gets the subject of this TemplateDetailResponse.
        The content to use for the Subject when this template is used to send email.

        :return: The subject of this TemplateDetailResponse.
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """
        Sets the subject of this TemplateDetailResponse.
        The content to use for the Subject when this template is used to send email.

        :param subject: The subject of this TemplateDetailResponse.
        :type: str
        """

        self._subject = subject

    @property
    def active(self):
        """
        Gets the active of this TemplateDetailResponse.
        Indicates that this template may be used for sending email.

        :return: The active of this TemplateDetailResponse.
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """
        Sets the active of this TemplateDetailResponse.
        Indicates that this template may be used for sending email.

        :param active: The active of this TemplateDetailResponse.
        :type: bool
        """

        self._active = active

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, TemplateDetailResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
